<?php
namespace Avaliacao\Entities;


use Geral\Util\NovoCodigo;
use Setforms2\Shared\Registry;

class AvlItemavalfilial extends Base\AvlItemavalfilial
{
    public static function consultaPeriodoVigencia($nrorg, $cdfilial, $dtinicial, $dtfinal, $dtinicial_old, $dtfinal_old){
        try {
            $obj = self::getObjectsByWhere(
                'NRORG = ? AND CDFILIAL = ? AND DTINICIALVIGENCIA <> ? AND DTFINALVIGENCIA <> ?
                 AND ((? BETWEEN DTINICIALVIGENCIA AND DTFINALVIGENCIA) OR (? BETWEEN DTINICIALVIGENCIA AND DTFINALVIGENCIA))',
                array(
                    $nrorg,
                    $cdfilial,
                    $dtinicial_old,
                    $dtfinal_old,
                    $dtinicial,
                    $dtfinal,
                )
            );

            return $obj;
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }

    public static function atualizaItemAvalPorData($nrorg, $cdfilial, $dtinicial, $dtfinal, $dtinicial_old, $dtfinal_old){
        $obj = self::retornaItemAvalPorData($nrorg, $cdfilial, $dtinicial_old, $dtfinal_old);
        /** @var $registro \Avaliacao\Entities\Base\AvlItemavalfilial */
        if (is_object($obj)){
            foreach($obj as $registro){
                $registro->setDtinicialvigencia($dtinicial);
                $registro->setDtfinalvigencia($dtfinal);
                $registro->setDtultatu(now());
                $registro->setCdoperultatu(\Geral\Util\Ambiente::getCdOperador());
                $registro->persist();
            }

            return true;
        }

        return false;
    }


    public static function retornaItemAvalPorData($nrorg, $cdfilial, $dtinicial, $dtfinal){
        if ($dtfinal == '1/1/1') {
            $where = '';
        } else {
            $where = " AND DTFINALVIGENCIA = '$dtfinal'";
        }

        try {
            $obj = self::getObjectsByWhere(
                'NRORG = ? AND CDFILIAL = ? AND DTINICIALVIGENCIA = ?'.$where,
                array(
                    $nrorg,
                    $cdfilial,
                    $dtinicial,
                )
            );

            return $obj;
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }

    public static function consultaHorarioItemAval($nritemava, $nrorg, $cdfilial, $dtinicial, $dtfinal, $horaini, $horafim, $localaval){
        try {
            $filtro = '1 = 1';

            if (!empty($nritemava)) $filtro .= " AND NRITEMAVALFILIAL <> '$nritemava' ";
            if (!empty($localaval)) $filtro .= " AND NRLOCALAVALIACAO = '$localaval' ";

            $sql = "SELECT *
                      FROM AVL_ITEMAVALFILIAL
                     WHERE $filtro
                       AND NRORG             = '$nrorg'
                       AND CDFILIAL          = '$cdfilial'
                       AND DTINICIALVIGENCIA = '$dtinicial'
                       AND (DTFINALVIGENCIA  = '$dtfinal' OR ('$dtfinal' IS NULL AND DTFINALVIGENCIA IS NULL))
                       AND (TO_DATE('$horaini', 'HH24:MI')
                            BETWEEN TO_DATE(HRINICIAL, 'HH24:MI')
                                AND CASE
                                    WHEN TO_DATE(HRFINAL, 'HH24:MI') < TO_DATE(HRINICIAL, 'HH24:MI')
                                    THEN TO_DATE(HRFINAL, 'HH24:MI')+1
                                    ELSE TO_DATE(HRFINAL, 'HH24:MI') END
                         OR TO_DATE('$horafim', 'HH24:MI')
                            BETWEEN TO_DATE(HRINICIAL, 'HH24:MI')
                                AND CASE
                                    WHEN TO_DATE(HRFINAL, 'HH24:MI') < TO_DATE(HRINICIAL, 'HH24:MI')
                                    THEN TO_DATE(HRFINAL, 'HH24:MI')+1
                                    ELSE TO_DATE(HRFINAL, 'HH24:MI') END
                         OR (TO_DATE('$horaini', 'HH24:MI') < TO_DATE(HRINICIAL, 'HH24:MI')
                         AND CASE
                             WHEN TO_DATE('$horafim', 'HH24:MI') < TO_DATE('$horaini', 'HH24:MI')
                             THEN TO_DATE('$horafim', 'HH24:MI')+1
                             ELSE TO_DATE('$horafim', 'HH24:MI') END > CASE
                         WHEN TO_DATE(HRFINAL, 'HH24:MI') < TO_DATE(HRINICIAL, 'HH24:MI')
                         THEN TO_DATE(HRFINAL, 'HH24:MI')+1
                         ELSE TO_DATE(HRFINAL, 'HH24:MI') END))";
            $array = \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);
//            $obj = \TkModelEntity::createObjectsFromArray($array);
            if (count($array) > 0){
                return $array;
            } else {
                return false;
            }
        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }

    public static function retornaMaiorDataVigenciaItem($nrorg, $filial){
        $query = "SELECT MAX(DTINICIALVIGENCIA) MAIOR
                    FROM AVL_ITEMAVALFILIAL
                   WHERE NRORG = {$nrorg}
                     AND CDFILIAL = {$filial}
                     AND (DTINICIALVIGENCIA < SYSDATE OR DTINICIALVIGENCIA = SYSDATE)
                     AND (DTFINALVIGENCIA > SYSDATE OR DTFINALVIGENCIA = SYSDATE OR DTFINALVIGENCIA IS NULL)";

        $result = \Setforms2\Runtime\Connection::getInstance()->fetchAll($query);
        return $result;
    }

    public static function consultaItemAvaliacaoFilial($nrorg, $filial, $data_vigencia_inicial, $local_avaliacao=null) {
        if (!empty($local_avaliacao)) {
            $objs = self::getObjectsByWhere(
                'NRORG = ? AND CDFILIAL = ? AND DTINICIALVIGENCIA = ? AND NRLOCALAVALIACAO = ?',
                array(
                    $nrorg,
                    $filial,
                    $data_vigencia_inicial,
                    $local_avaliacao,
                )
            );
            if (!is_array($objs)) {
                $objs = self::getObjectsByWhere(
                    'NRORG = ? AND CDFILIAL = ? AND DTINICIALVIGENCIA = ? AND NRLOCALAVALIACAO IS NULL',
                    array(
                        $nrorg,
                        $filial,
                        $data_vigencia_inicial,
                    )
                );
            }

            return $objs;

        } else {
            $objs = self::getObjectsByWhere(
                'NRORG = ? AND CDFILIAL = ? AND DTINICIALVIGENCIA = ?',
                array(
                    $nrorg,
                    $filial,
                    $data_vigencia_inicial,
                )
            );

            return $objs;
        }

    }

    public static function retornaItemAvaliacaoFilial($nrorg, $filial, $data_vigencia_inicial, $local_avaliacao=null) {
        if (!empty($local_avaliacao)) {// veio null
            $objs = self::getObjectsByWhere(
                'NRORG = ? AND CDFILIAL = ? AND DTINICIALVIGENCIA = ? AND NRLOCALAVALIACAO = ?',
                array(
                    $nrorg,
                    $filial,
                    $data_vigencia_inicial,
                    $local_avaliacao,
                )
            );
            if (!is_array($objs)) {
                $objs = self::getObjectsByWhere(
                    'NRORG = ? AND CDFILIAL = ? AND DTINICIALVIGENCIA = ? AND NRLOCALAVALIACAO IS NULL',
                    array(
                        $nrorg,
                        $filial,
                        $data_vigencia_inicial,
                    )
                );
            }

            return $objs;

        } else {
            $objs = self::getObjectsByWhere(
                'NRORG = ? AND CDFILIAL = ? AND DTINICIALVIGENCIA = ?',
                array(
                    $nrorg,
                    $filial,
                    $data_vigencia_inicial,
                )
            );

            return $objs;
        }

    }


    public function retornaItensAvaliacaoFilial($nrorg, $cdfilial) {
        $objs = self::getObjectsByWhere(
            'NRORG = ? AND CDFILIAL = ?',
            array(
                $nrorg,
                $cdfilial,
            )
        );
        return $objs;
    }

    public function retornaItemAvaliacao($nrorg, $cdfilial, $nritemavaliacao, $nrlocalavaliacao) {
        $obj = self::getObjectByWhere(
            'NRORG = ? AND CDFILIAL = ? AND NRITEMAVALIACAO = ? AND NRLOCALAVALIACAO = ?',
            array(
                $nrorg,
                $cdfilial,
                $nritemavaliacao,
                $nrlocalavaliacao,
            )
        );
        if (!is_object($obj)) {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND CDFILIAL = ? AND NRITEMAVALIACAO = ? AND NRLOCALAVALIACAO IS NULL',
                array(
                    $nrorg,
                    $cdfilial,
                    $nritemavaliacao,
                )
            );

        }
        return $obj;
    }

    public function incluiItemAvaliacaoFilial($nrorg, $cdfilial, $nritemavaliacao, $local_avaliacao, $dt_inicio_vigencia, $dt_fim_vigencia, $hora_inicial, $hora_final) {
        try {
            $obj = new self();
            $obj->setNrorg($nrorg);
            $obj->setCdfilial($cdfilial);
            $obj->setNritemavaliacao($nritemavaliacao);
            $obj->setNritemavalfilial(NovoCodigo::geraCodigo($nrorg, 'AVL_ITEMAVALFILIAL',1,10,true));
            $obj->setNrlocalavaliacao($local_avaliacao);
            $obj->setDtinicialvigencia($dt_inicio_vigencia);
            $obj->setDtfinalvigencia($dt_fim_vigencia);
            $obj->setHrinicial($hora_inicial);
            $obj->setHrfinal($hora_final);
            $obj->setNrorginclusao($nrorg);
            $obj->setNrorgultatu($nrorg);
            $obj->setIdativo('S');
            $obj->persist();

            Registry::getEntityManager()->flush();

        } catch (\Exception $e) {
            tk_warning('Erro '.$e->getMessage());
        }
    }


}