<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Geral\Logic\PropostaComercial;

use Windows\WinInt00201000\TabInt00201000011\Facade;
use Faturamento\Entities\Propostalinp;
use Faturamento\Entities\Venclusoprop;
use Setforms2\Runtime\Connection;
use Setforms2\Shared\Registry;
use Geral\Util\DateUtil;

/**
 * Description of NegociarLinhaProduto
 *
 * @author phillipesilva
 */

class NegociarLinhaProduto {
    public static function insertParcelas($nrProposta, $nrVersao, $dtVenc, $nrOrg, $vrVencParc, $cdLinpProp)
    {
        $db = Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = Registry::getEntityManager();
        $dtInclusao = DateUtil::getDataAtual();
        
        try{            
            $vencLusoProp = new Venclusoprop();
            $vencLusoProp->setNrproposfas($nrProposta);
            $vencLusoProp->setNrverpropfas($nrVersao);
            $vencLusoProp->setDtvelusopedp($dtVenc);
            $vencLusoProp->setVrvelusopedp($vrVencParc);
            $vencLusoProp->setCdlinpprop($cdLinpProp);
            $vencLusoProp->setDtinclusao($dtInclusao);
            $vencLusoProp->setNrorg($nrOrg);
            
            $vencLusoProp->persist();
            
            $connection->flush();

            $db->getConn()->commit();                
        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }
    }
    
    public static function deleteParcelas($nrProposta, $nrVersao, $nrOrg, $cdLinpProp)
    {
        $db = Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = Registry::getEntityManager();  
        
        try {
            $vencLusoProp = Venclusoprop::findByNrproposfasAndNrverpropfasAndNrorgAndCdlinpprop($nrProposta, $nrVersao, $nrOrg, $cdLinpProp);

            if (is_array($vencLusoProp)) {
                foreach ($vencLusoProp as $venc) {
                    $venc->delete();
                }
            }

            $connection->flush();

            $db->getConn()->commit();
        } catch (\Exception $e) {
            $db->getConn()->rollback();
            throw $e;
        }
    }
    
    public static function recalcularVrTotalComJuros($vrTotal, $dtVenc, $qtParc, $txJuros)
    {
        $vrParcelaSemJuros = $vrTotal / $qtParc;
        $txJurosPriMes     = pow(1 + $txJuros / 100, 1 / 30);
        $vrTotalParcCalc   = 0;
        $dtPriParcela      = Facade::geraData($dtVenc, 1);
        $dataProxParc      = $dtPriParcela;
        
        for ($i = 0; $i < $qtParc; $i++) {
            $dataProxParc      = Facade::geraData($dataProxParc, 2);
            $diferencaDias     = DateUtil::getQtdeDiasEntre($dtPriParcela, $dataProxParc);
            $vrParcelaComJuros = pow($txJurosPriMes, $diferencaDias) * $vrParcelaSemJuros;
            $vrTotalParcCalc  += $vrParcelaComJuros;
        }

        return $vrTotalParcCalc;
    }
    
    public static function atualizaValoresLinhaProduto($nrProposta, $nrVersao, $cdLinpProp, $nrOrg, $tipoLinhaProd,
                                                       $vrLicUso, $vrDescLicUso, $vrMensal, $vrDescMensal, $dtCarencia)
    {
        $db = Connection::getInstance();
        $db->getConn()->beginTransaction();
        $manager  = Registry::getEntityManager();
        $propLinp = Propostalinp::findOneByNrproposfasAndNrverpropfasAndNrorgAndCdlinpprop($nrProposta, $nrVersao, $nrOrg, $cdLinpProp);
        
        try{
            //Produto
            if($tipoLinhaProd == 'M' || $tipoLinhaProd == 'L'){
                $propLinp->setVrlicencusoprop($vrLicUso);
                $propLinp->setVrdeslicusoprop($vrDescLicUso);
                $propLinp->setVrmensalidaprop($vrMensal);
                $propLinp->setVrdesmensalprop($vrDescMensal);
            }
            //Pto. Acesso
            elseif($tipoLinhaProd == 'A' || $tipoLinhaProd == 'P'){
                $propLinp->setVrlusopropptoa($vrLicUso);
                $propLinp->setVrdlusopropptoa($vrDescLicUso);
                $propLinp->setVrmenspropptoa($vrMensal);
                $propLinp->setVrdmenspropptoa($vrDescMensal);
            }
            
            if($dtCarencia == ''){
                $propLinp->setDtcaluslinpp(null);
            } else {
                $propLinp->setDtcaluslinpp($dtCarencia);
            }
            
            $propLinp->persist();

            $manager->flush();        

            $db->getConn()->commit();                
        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }
    }
    
    public static function setDataCarenciaLinP($param)
    {
        $db = Connection::getInstance();
        $db->getConn()->beginTransaction();
        $manager  = Registry::getEntityManager();
        $propLinp = Propostalinp::findOneByNrproposfasAndNrverpropfasAndNrorgAndCdlinpprop($param['PROPOSTA'], $param['VERSAO'], $param['NRORG'], $param['CODIGOLP']);
        
        try {
            if (is_object($propLinp)) {
                $propLinp->setDtcaluslinpp($param['DATACARENCIA']);
                $propLinp->persist();
            }

            $manager->flush();

            $db->getConn()->commit();
        } catch (\Exception $e) {
            $db->getConn()->rollback();
            throw $e;
        }
    }

    public static function recalcularParcelas($dataSetParc, $parcelas, $nrOrg, $vrTotal, $dtProposta)
    {
        $db = Connection::getInstance();
        $db->getConn()->beginTransaction();
        $manager = Registry::getEntityManager();

        try {
            $vrTotalUpdate  = 0;
            $messageRetorno = false;

            //Busca o valor total das parcelas alteradas e valida se a Data informada é anterior à data da proposta
            foreach($dataSetParc['UPDATE'] as $parcUpdate) {
                $vrTotalUpdate += $parcUpdate['VRVELUSOPEDP'];
                $dtVenc = DateUtil::getDataDeString(substr($parcUpdate['DTVELUSOPEDP'], 0, 10));
                $dtProp = DateUtil::getDataDeString(substr($dtProposta, 0, 10));

                if(DateUtil::comparaDatas($dtVenc, $dtProp)) {
                    $messageRetorno = 'DATA';
                }
            }

            if($vrTotalUpdate > $vrTotal) {
                $messageRetorno = 'VRTOTAL';
            } else if($messageRetorno != 'DATA'){
                $valorRestante = $vrTotal - $vrTotalUpdate;
                $countNoUpdate = count($dataSetParc['NOUPDATE']);

                if($countNoUpdate == 0) {
                    $countNoUpdate = 1;
                }

                $valorParcRestante = $valorRestante / $countNoUpdate;

                foreach($parcelas as $parcela) {
                    foreach($dataSetParc['UPDATE'] as $parcUpdate) {
                        if($parcela['NRPARCELA'] == $parcUpdate['NRPARCELA']){
                            self::updateParcela($parcUpdate, $parcela, $nrOrg);
                        }
                    }
                }

                foreach($dataSetParc['NOUPDATE'] as $parcNoUpdate) {
                    $parcNoUpdate['VRVELUSOPEDP'] = $valorParcRestante;
                    self::updateParcela($parcNoUpdate, null, $nrOrg);
                }
            }

            $manager->flush();
            $db->getConn()->commit();
        } catch (\Exception $e) {
            $db->getConn()->rollback();
            throw $e;
        }

        return $messageRetorno;
    }

    public static function updateParcela($parcUpdate, $parcOld, $nrOrg)
    {
        $where = "NRPROPOSFAS  = ?
              AND NRVERPROPFAS = ?
              AND CDLINPPROP   = ?
              AND NRORG        = ?
              AND TO_CHAR(DTVELUSOPEDP, 'DD/MM/YYYY') = ?";



        //Se $parcOld tiver valor significa que estão sendo levadas em consideração as parcelas que o usuário alterou.
        if($parcOld) {
            $params = array($parcUpdate['NRPROPOSFAS'],
                            $parcUpdate['NRVERPROPFAS'],
                            $parcUpdate['CDLINPPROP'],
                            $nrOrg,
                            $parcOld['DTVELUSOPEDP']);
        } else {
            $params = array($parcUpdate['NRPROPOSFAS'],
                            $parcUpdate['NRVERPROPFAS'],
                            $parcUpdate['CDLINPPROP'],
                            $nrOrg,
                            $parcUpdate['DTVELUSOPEDP']);
        }

        $vencLuso = Venclusoprop::getObjectByWhere($where, $params);

        if(is_object($vencLuso)) {
            $vencLuso->setVrvelusopedp($parcUpdate['VRVELUSOPEDP']);

            if($parcOld) {
                $vencLuso->setDtvelusopedp(DateUtil::getDataDeString($parcUpdate['DTVELUSOPEDP'], DateUtil::FORMATO_BRASILEIRO, true));
            }

            Registry::getEntityManager()->flush();
        }
    }
}