/*
 Tecnisa - Tecnologia em Informtica

 Nome: GERA_TRAB_PREV_PANFLOR - 1070_FINSTP_GERA_TRAB_PREV_PANFLOR.SQL

 Descrio:
 Grava os dados referentes ao relatrio de Fluxo de Caixa (Formulrio)

 Criao:
 16/12/2004 -

           DBMS_OUTPUT.PUT_LINE(V_NRCOLUNA||'-'||C_DATA.DTDATA||'-'||V_IDATRASO);

*/

CREATE OR REPLACE PROCEDURE GERA_TRAB_PREV_PANFLOR
   (P_CDFILIAL    IN TRAB_PREV.CDFILIPREV%TYPE,
    P_NRPREVISAO  IN TRAB_PREV.NRPREVISAO%TYPE,
    P_DTPERIINIC  IN DATE,
    P_DTPERIFINA  IN DATE,
    P_CDEMPRESA   IN VARCHAR2)

AS
   V_NRPAGINA    NUMBER;
   V_NRREGIENCA  NUMBER;
   V_NRCOLUNA    NUMBER;
   V_TOTALDIA    NUMBER;
   V_CTSALDO     NUMBER;
   V_CTCONTA     NUMBER;
   V_TOTMOVIANT  NUMBER;
   V_IDATRASO    VARCHAR2(1);
   V_ISEMPTY     VARCHAR2(1);
   V_INDIA       INTEGER;
   V_INPERIODO   INTEGER;
   V_DTPERIODO   DATE;

   V_DTPERI_01   DATE;
   V_DTPERI_02   DATE;
   V_DTPERI_03   DATE;
   V_DTPERI_04   DATE;
   V_DTPERI_05   DATE;
   V_DTPERI_06   DATE;
   V_DTPERI_07   DATE;
   V_DTPERI_08   DATE;
   V_SALDO       NUMBER;


   CURSOR C_BANCOS IS
      SELECT DISTINCT
         CC.CDEMPRESA, BC.CDBANCO, BC.NMBANCO
      FROM CONTCORR CC, BANCO BC
      WHERE (CC.CDBANCO  = BC.CDBANCO) AND
            (P_CDEMPRESA = 'T' OR INSTR(P_CDEMPRESA, CDEMPRESA) <> 0)
      ORDER BY CC.CDEMPRESA, BC.CDBANCO;

   CURSOR C_EMPRESA IS
      SELECT CDEMPRESA, NMEMPRESA
      FROM EMPRESA
      WHERE
         (P_CDEMPRESA = 'T' OR INSTR(P_CDEMPRESA, CDEMPRESA) <> 0)
      ORDER BY CDEMPRESA;

   CURSOR C_CLASSFINANC IS
      SELECT CDCLASSFINA, DSCLASSFINA
      FROM CLASSFINANC
      ORDER BY CDCLASSFINA;

BEGIN

   V_NRREGIENCA := 1;
   V_NRCOLUNA   := 1;
   V_NRPAGINA   := 1;

/*  ##################################################################################################################*/
/*  ####################################  CONTAS A RECEBER  ##########################################################*/
/*  ##################################################################################################################*/
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_INDIA      := 0;
         V_INPERIODO  := 0;
         V_NRPAGINA   := 1;

         /* GRAVA OS VALORES DAS CONTAS A RECEBER EM ATRASO */
         SELECT SUM(CR.VRATUAREC) INTO V_TOTALDIA
         FROM
            (SELECT SUM(CR.VRATUAREC) VRATUAREC
             FROM
                NOTAFISCAL   NF,
                CONTARECEBER CR
             WHERE
                CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                CR.DTATUAVENREC <= P_DTPERIINIC - 2    AND
                CR.IDSTATREC IN ('A', 'E')             AND
                NF.CDFILIAL     = CR.CDFILIAL          AND
                NF.NRLANCTONF   = CR.NRLANCTONF        AND
                NF.IDSTATUS  IN ('A', 'E')
             UNION
             SELECT SUM(MJ.VRFXAJBOLREC) VRATUAREC
             FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ
             WHERE
                MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                MJ.DTMOVFLUXO  <= P_DTPERIINIC - 2    AND
                MJ.IDMOVFLUXO  = 'E'                  AND
                MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                TA.IDAJUCTREC  = 'A'
             UNION
             SELECT SUM(MJ.VRFXAJBOLREC * -1) VRATUAREC
             FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ
             WHERE
                MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                MJ.DTMOVFLUXO  <= P_DTPERIINIC - 2    AND
                MJ.IDMOVFLUXO  = 'E'                  AND
                MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                TA.IDAJUCTREC  = 'D') CR;

         V_IDATRASO := 'N';
         IF V_TOTALDIA > 0 THEN
            INSERT INTO TRAB_PREV(
               CDFILIPREV,   NRPREVISAO, NRREGIPREV,
               NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
               CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
               DTINIPERPREV, DTFINPERPREV)
            VALUES(
               P_CDFILIAL,          P_NRPREVISAO,        LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
               V_NRPAGINA,          '01',                C_EMP.CDEMPRESA,
               C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA, V_TOTALDIA,
               P_DTPERIINIC,        P_DTPERIFINA);

               V_IDATRASO := 'S';
         END IF;

         SELECT COUNT(*) INTO V_CTCONTA
         FROM CONTARECEBER
         WHERE
            CDEMPRESA    = C_EMP.CDEMPRESA     AND
            CDCLASSFINA  = C_CLASS.CDCLASSFINA AND
            DTATUAVENREC BETWEEN (P_DTPERIINIC - 1) AND P_DTPERIFINA;

         IF (V_IDATRASO = 'S') OR (V_CTCONTA > 0) THEN
            /* GRAVA OS VALORES DAS CONTAS A RECEBER */
            V_NRCOLUNA  := 1;
            V_INDIA     := 0;
            V_INPERIODO := 0;

/*  ####################################     DIARIO    ##########################################################*/
            WHILE V_INDIA <= 3 LOOP
               V_TOTALDIA := 0;
               FOR C_CNTREC IN (
                  SELECT SUM(CR.VRATUAREC) VRATUAREC
                  FROM
                     NOTAFISCAL   NF,
                     CONTARECEBER CR
                  WHERE
                     CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                     CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                     CR.DTATUAVENREC = P_DTPERIINIC + V_INDIA        AND
                     CR.IDSTATREC IN ('A', 'E')             AND
                     NF.CDFILIAL     = CR.CDFILIAL          AND
                     NF.NRLANCTONF   = CR.NRLANCTONF        AND
                     NF.IDSTATUS  IN ('A', 'E')
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLREC) VRATUAREC
                  FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO  = P_DTPERIINIC + V_INDIA       AND
                     MJ.IDMOVFLUXO  = 'E'                  AND
                     MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                     TA.IDAJUCTREC  = 'A'
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLREC * -1) VRATUAREC
                  FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO  = P_DTPERIINIC + V_INDIA       AND
                     MJ.IDMOVFLUXO  = 'E'                  AND
                     MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                     TA.IDAJUCTREC  = 'D') LOOP
                  IF C_CNTREC.VRATUAREC IS NULL THEN
                     V_TOTALDIA := V_TOTALDIA + 0;
                  ELSE
                     V_TOTALDIA := V_TOTALDIA + C_CNTREC.VRATUAREC;
                  END IF;
               END LOOP;

               IF (V_NRCOLUNA > 1) OR (V_IDATRASO = 'S') THEN
                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                   V_NRCOLUNA, P_DTPERIINIC + V_INDIA, V_TOTALDIA);
               ELSE
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,          P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,          '01',         C_EMP.CDEMPRESA,
                     C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA,
                     P_DTPERIINIC + V_INDIA,       V_TOTALDIA,
                     P_DTPERIINIC,        P_DTPERIFINA);
               END IF;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 10 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
                  V_IDATRASO   := 'N';
               END IF;
               V_INDIA    := V_INDIA + 1;
            END LOOP;

/*  ####################################     SEMANAL    ##########################################################*/
            V_DTPERIODO := P_DTPERIINIC + V_INDIA;
            V_INPERIODO := 0;

            WHILE V_INPERIODO <= 2 LOOP
               V_TOTALDIA := 0;
               FOR C_CNTREC IN (
                  SELECT SUM(CR.VRATUAREC) VRATUAREC
                  FROM
                     NOTAFISCAL   NF,
                     CONTARECEBER CR
                  WHERE
                     CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                     CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                     CR.DTATUAVENREC BETWEEN V_DTPERIODO AND V_DTPERIODO + 6 AND
                     CR.IDSTATREC IN ('A', 'E')             AND
                     NF.CDFILIAL     = CR.CDFILIAL          AND
                     NF.NRLANCTONF   = CR.NRLANCTONF        AND
                     NF.IDSTATUS  IN ('A', 'E')
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLREC) VRATUAREC
                  FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO  BETWEEN V_DTPERIODO AND V_DTPERIODO + 6 AND
                     MJ.IDMOVFLUXO  = 'E'                  AND
                     MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                     TA.IDAJUCTREC  = 'A'
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLREC * -1) VRATUAREC
                  FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO  BETWEEN V_DTPERIODO AND V_DTPERIODO + 6 AND
                     MJ.IDMOVFLUXO  = 'E'                  AND
                     MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                     TA.IDAJUCTREC  = 'D') LOOP
                  IF C_CNTREC.VRATUAREC IS NULL THEN
                     V_TOTALDIA := V_TOTALDIA + 0;
                  ELSE
                     V_TOTALDIA := V_TOTALDIA + C_CNTREC.VRATUAREC;
                  END IF;
               END LOOP;

               IF (V_NRCOLUNA > 1) OR (V_IDATRASO = 'S') THEN
                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                   V_NRCOLUNA, V_DTPERIODO, V_TOTALDIA);
               ELSE
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,          P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,          '01',         C_EMP.CDEMPRESA,
                     C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA,
                     V_DTPERIODO,         V_TOTALDIA,
                     P_DTPERIINIC,        P_DTPERIFINA);
               END IF;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 10 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
                  V_IDATRASO   := 'N';
               END IF;
               V_DTPERIODO := V_DTPERIODO + 7;
               V_INPERIODO := V_INPERIODO + 1;
            END LOOP;

/*  ####################################     MENSAL    ##########################################################*/

            V_TOTALDIA := 0;
            FOR C_CNTREC IN (
               SELECT SUM(CR.VRATUAREC) VRATUAREC
               FROM
                  NOTAFISCAL   NF,
                  CONTARECEBER CR
               WHERE
                  CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                  CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                  CR.DTATUAVENREC BETWEEN V_DTPERIODO AND V_DTPERIODO + 30 AND
                  CR.IDSTATREC IN ('A', 'E')             AND
                  NF.CDFILIAL     = CR.CDFILIAL          AND
                  NF.NRLANCTONF   = CR.NRLANCTONF        AND
                  NF.IDSTATUS  IN ('A', 'E')
               UNION
               SELECT SUM(MJ.VRFXAJBOLREC) VRATUAREC
               FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ
               WHERE
                  MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                  MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                  MJ.DTMOVFLUXO  BETWEEN V_DTPERIODO AND V_DTPERIODO + 30 AND
                  MJ.IDMOVFLUXO  = 'E'                  AND
                  MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                  TA.IDAJUCTREC  = 'A'
               UNION
               SELECT SUM(MJ.VRFXAJBOLREC * -1) VRATUAREC
               FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ
               WHERE
                  MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                  MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                  MJ.DTMOVFLUXO  BETWEEN V_DTPERIODO AND V_DTPERIODO + 30 AND
                  MJ.IDMOVFLUXO  = 'E'                  AND
                  MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                  TA.IDAJUCTREC  = 'D') LOOP
               IF C_CNTREC.VRATUAREC IS NULL THEN
                  V_TOTALDIA := V_TOTALDIA + 0;
               ELSE
                  V_TOTALDIA := V_TOTALDIA + C_CNTREC.VRATUAREC;
               END IF;
            END LOOP;

            IF (V_NRCOLUNA > 1) OR (V_IDATRASO = 'S') THEN
               ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                V_NRCOLUNA, V_DTPERIODO, V_TOTALDIA);
            ELSE
               INSERT INTO TRAB_PREV(
                  CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                  NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                  CDITEMPREV,   DSITEMPREV,
                  DTDIA01PREV,  VRDIA01PREV,
                  DTINIPERPREV, DTFINPERPREV)
               VALUES(
                  P_CDFILIAL,          P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                  V_NRPAGINA,          '01',         C_EMP.CDEMPRESA,
                  C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA,
                  V_DTPERIODO,         V_TOTALDIA,
                  P_DTPERIINIC,        P_DTPERIFINA);
            END IF;

            /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
            V_NRCOLUNA   := V_NRCOLUNA + 1;
            IF V_NRCOLUNA > 10 THEN
               V_NRPAGINA   := V_NRPAGINA + 1;
               V_NRCOLUNA   := 1;
               V_NRREGIENCA := V_NRREGIENCA + 1;
               V_IDATRASO   := 'N';
            END IF;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
   END LOOP;


/*  ##################################################################################################################*/
/*  ####################################   CONTAS A PAGAR   ##########################################################*/
/*  ##################################################################################################################*/
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_INDIA      := 0;
         V_INPERIODO  := 0;
         V_NRPAGINA   := 1;

         /* GRAVA OS VALORES DAS CONTAS A PAGAR EM ATRASO */
         SELECT SUM(CP.VRATUAPAG) INTO V_TOTALDIA
         FROM
            (SELECT SUM(CP.VRATUAPAG) VRATUAPAG
             FROM
                NOTAFISCAL NF,
                CONTAPAGAR CP
             WHERE
                CP.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                CP.DTATUAVENPAG <= P_DTPERIINIC - 2    AND
                CP.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                CP.IDSTATPAG    = 'A'                  AND
                NF.CDFILIAL     = CP.CDFILIAL          AND
                NF.NRLANCTONF   = CP.NRLANCTONF        AND
                NF.IDSTATUS     IN ('A', 'E')
             UNION
             SELECT SUM(MJ.VRFXAJBOLPAG) VRATUAPAG
             FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ
             WHERE
                MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                MJ.DTMOVFLUXO  <= P_DTPERIINIC - 2    AND
                MJ.IDMOVFLUXO  = 'E'                  AND
                MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                TA.IDAJUCTPAG  = 'A'
             UNION
             SELECT SUM(MJ.VRFXAJBOLPAG * -1) VRATUAPAG
             FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ
             WHERE
                MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                MJ.DTMOVFLUXO  <= P_DTPERIINIC - 2    AND
                MJ.IDMOVFLUXO  = 'E'                  AND
                MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                TA.IDAJUCTPAG  = 'D') CP;

         V_IDATRASO := 'N';
         IF V_TOTALDIA > 0 THEN
            INSERT INTO TRAB_PREV(
               CDFILIPREV,   NRPREVISAO, NRREGIPREV,
               NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
               CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
               DTINIPERPREV, DTFINPERPREV)
            VALUES(
               P_CDFILIAL,          P_NRPREVISAO,        LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
               V_NRPAGINA,          '10',                C_EMP.CDEMPRESA,
               C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA, -V_TOTALDIA,
               P_DTPERIINIC,        P_DTPERIFINA);

               V_IDATRASO := 'S';
         END IF;

         SELECT COUNT(*) INTO V_CTCONTA
         FROM CONTAPAGAR
         WHERE
            CDEMPRESA    = C_EMP.CDEMPRESA     AND
            CDCLASSFINA  = C_CLASS.CDCLASSFINA AND
            DTATUAVENPAG BETWEEN (P_DTPERIINIC - 1) AND P_DTPERIFINA;

         IF (V_IDATRASO = 'S') OR (V_CTCONTA > 0) THEN
            /* GRAVA OS VALORES DAS CONTAS A PAGAR */
            V_NRCOLUNA  := 1;
            V_INDIA     := 0;
            V_INPERIODO := 0;

/*  ####################################     DIARIO    ##########################################################*/
            WHILE V_INDIA <= 3 LOOP
               V_TOTALDIA := 0;
               FOR C_CNTREC IN (
                  SELECT SUM(CP.VRATUAPAG) VRATUAPAG
                  FROM
                     NOTAFISCAL NF,
                     CONTAPAGAR CP
                  WHERE
                     CP.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                     CP.DTATUAVENPAG = P_DTPERIINIC + V_INDIA        AND
                     CP.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                     CP.IDSTATPAG    = 'A'                  AND
                     NF.CDFILIAL     = CP.CDFILIAL          AND
                     NF.NRLANCTONF   = CP.NRLANCTONF        AND
                     NF.IDSTATUS  IN ('A', 'E')
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLPAG) VRATUAPAG
                  FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO  = P_DTPERIINIC + V_INDIA        AND
                     MJ.IDMOVFLUXO  = 'E'                  AND
                     MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                     TA.IDAJUCTPAG  = 'A'
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLPAG * -1) VRATUAPAG
                  FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO  = P_DTPERIINIC + V_INDIA        AND
                     MJ.IDMOVFLUXO  = 'E'                  AND
                     MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                     TA.IDAJUCTPAG  = 'D') LOOP
                  IF C_CNTREC.VRATUAPAG IS NULL THEN
                     V_TOTALDIA := V_TOTALDIA + 0;
                  ELSE
                     V_TOTALDIA := V_TOTALDIA - C_CNTREC.VRATUAPAG;
                  END IF;
               END LOOP;

               IF (V_NRCOLUNA > 1) OR (V_IDATRASO = 'S') THEN
                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                   V_NRCOLUNA, P_DTPERIINIC + V_INDIA, V_TOTALDIA);
               ELSE
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,          P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,          '10',         C_EMP.CDEMPRESA,
                     C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA,
                     P_DTPERIINIC + V_INDIA,        V_TOTALDIA,
                     P_DTPERIINIC,        P_DTPERIFINA);
               END IF;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 10 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
                  V_IDATRASO   := 'N';
               END IF;
               V_INDIA    := V_INDIA + 1;
            END LOOP;

/*  ####################################     SEMANAL    ##########################################################*/
            V_DTPERIODO := P_DTPERIINIC + V_INDIA;
            V_INPERIODO := 0;

            WHILE V_INPERIODO <= 2 LOOP
               V_TOTALDIA := 0;
               FOR C_CNTREC IN (
                  SELECT SUM(CP.VRATUAPAG) VRATUAPAG
                  FROM
                     NOTAFISCAL NF,
                     CONTAPAGAR CP
                  WHERE
                     CP.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                     CP.DTATUAVENPAG  BETWEEN V_DTPERIODO AND V_DTPERIODO + 6 AND
                     CP.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                     CP.IDSTATPAG    = 'A'                  AND
                     NF.CDFILIAL     = CP.CDFILIAL          AND
                     NF.NRLANCTONF   = CP.NRLANCTONF        AND
                     NF.IDSTATUS  IN ('A', 'E')
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLPAG) VRATUAPAG
                  FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO   BETWEEN V_DTPERIODO AND V_DTPERIODO + 6 AND
                     MJ.IDMOVFLUXO  = 'E'                  AND
                     MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                     TA.IDAJUCTPAG  = 'A'
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLPAG * -1) VRATUAPAG
                  FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO   BETWEEN V_DTPERIODO AND V_DTPERIODO + 6 AND
                     MJ.IDMOVFLUXO  = 'E'                  AND
                     MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                     TA.IDAJUCTPAG  = 'D') LOOP
                  IF C_CNTREC.VRATUAPAG IS NULL THEN
                     V_TOTALDIA := V_TOTALDIA + 0;
                  ELSE
                     V_TOTALDIA := V_TOTALDIA - C_CNTREC.VRATUAPAG;
                  END IF;
               END LOOP;

               IF (V_NRCOLUNA > 1) OR (V_IDATRASO = 'S') THEN
                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                   V_NRCOLUNA, V_DTPERIODO, V_TOTALDIA);
               ELSE
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,          P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,          '10',         C_EMP.CDEMPRESA,
                     C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA,
                     V_DTPERIODO,         V_TOTALDIA,
                     P_DTPERIINIC,        P_DTPERIFINA);
               END IF;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 10 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
                  V_IDATRASO   := 'N';
               END IF;
               V_DTPERIODO := V_DTPERIODO + 7;
               V_INPERIODO := V_INPERIODO + 1;
            END LOOP;

/*  ####################################     MENSAL    ##########################################################*/

            V_TOTALDIA := 0;
            FOR C_CNTREC IN (
               SELECT SUM(CP.VRATUAPAG) VRATUAPAG
               FROM
                  NOTAFISCAL NF,
                  CONTAPAGAR CP
               WHERE
                  CP.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                  CP.DTATUAVENPAG  BETWEEN V_DTPERIODO AND V_DTPERIODO + 30 AND
                  CP.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                  CP.IDSTATPAG    = 'A'                  AND
                  NF.CDFILIAL     = CP.CDFILIAL          AND
                  NF.NRLANCTONF   = CP.NRLANCTONF        AND
                  NF.IDSTATUS  IN ('A', 'E')
               UNION
               SELECT SUM(MJ.VRFXAJBOLPAG) VRATUAPAG
               FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ
               WHERE
                  MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                  MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                  MJ.DTMOVFLUXO   BETWEEN V_DTPERIODO AND V_DTPERIODO + 30 AND
                  MJ.IDMOVFLUXO  = 'E'                  AND
                  MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                  TA.IDAJUCTPAG  = 'A'
               UNION
               SELECT SUM(MJ.VRFXAJBOLPAG * -1) VRATUAPAG
               FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ
               WHERE
                  MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                  MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                  MJ.DTMOVFLUXO   BETWEEN V_DTPERIODO AND V_DTPERIODO + 30 AND
                  MJ.IDMOVFLUXO  = 'E'                  AND
                  MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                  TA.IDAJUCTPAG  = 'D') LOOP
               IF C_CNTREC.VRATUAPAG IS NULL THEN
                  V_TOTALDIA := V_TOTALDIA + 0;
               ELSE
                  V_TOTALDIA := V_TOTALDIA - C_CNTREC.VRATUAPAG;
               END IF;
            END LOOP;

            IF (V_NRCOLUNA > 1) OR (V_IDATRASO = 'S') THEN
               ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                V_NRCOLUNA, V_DTPERIODO, V_TOTALDIA);
            ELSE
               INSERT INTO TRAB_PREV(
                  CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                  NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                  CDITEMPREV,   DSITEMPREV,
                  DTDIA01PREV,  VRDIA01PREV,
                  DTINIPERPREV, DTFINPERPREV)
               VALUES(
                  P_CDFILIAL,          P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                  V_NRPAGINA,          '10',         C_EMP.CDEMPRESA,
                  C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA,
                  V_DTPERIODO,         V_TOTALDIA,
                  P_DTPERIINIC,        P_DTPERIFINA);
            END IF;

            /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
            V_NRCOLUNA   := V_NRCOLUNA + 1;
            IF V_NRCOLUNA > 10 THEN
               V_NRPAGINA   := V_NRPAGINA + 1;
               V_NRCOLUNA   := 1;
               V_NRREGIENCA := V_NRREGIENCA + 1;
               V_IDATRASO   := 'N';
            END IF;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
   END LOOP;


/*  ##################################################################################################################*/
/*  ####################################  SALDO DOS BANCOS  ##########################################################*/
/*  ##################################################################################################################*/

   V_DTPERI_01 := P_DTPERIINIC ;
   V_DTPERI_02 := P_DTPERIINIC + 1;
   V_DTPERI_03 := P_DTPERIINIC + 2;
   V_DTPERI_04 := P_DTPERIINIC + 3;
   V_DTPERI_05 := P_DTPERIINIC + 4;
   V_DTPERI_06 := P_DTPERIINIC + 11;
   V_DTPERI_07 := P_DTPERIINIC + 18;
   V_DTPERI_08 := P_DTPERIINIC + 25;

   FOR C_BC IN C_BANCOS LOOP
      V_NRCOLUNA   := 0;
      V_NRPAGINA   := 1;
      V_SALDO      := 0;
      SELECT COUNT(*) INTO V_CTSALDO
      FROM CONTCORR CC, SDOCCORR SC
      WHERE
         (CC.CDREDUCONT = SC.CDREDUCONT)    AND
         (CC.CDEMPRESA  = C_BC.CDEMPRESA)   AND
         (CC.CDBANCO    = C_BC.CDBANCO)     AND
         (SC.DTSDOCCORR IN (SELECT MAX(DTSDOCCORR)
                            FROM SDOCCORR
                            WHERE
                               CDREDUCONT = SC.CDREDUCONT AND
                               DTSDOCCORR <= P_DTPERIINIC));

      V_TOTALDIA := 0;
      IF V_CTSALDO > 0 THEN
         SELECT SUM(VRSDOCCORR) INTO V_TOTALDIA
         FROM CONTCORR CC, SDOCCORR SC
         WHERE
            (CC.CDREDUCONT = SC.CDREDUCONT)    AND
            (CC.CDEMPRESA  = C_BC.CDEMPRESA)   AND
            (CC.CDBANCO    = C_BC.CDBANCO)     AND
            (SC.DTSDOCCORR IN (SELECT MAX(DTSDOCCORR)
                               FROM SDOCCORR
                               WHERE
                                  CDREDUCONT = SC.CDREDUCONT AND
                                  DTSDOCCORR <= P_DTPERIINIC));
      END IF;

      IF V_TOTALDIA <> 0 THEN

         INSERT INTO TRAB_PREV(
            CDFILIPREV,   NRPREVISAO, NRREGIPREV,
            NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
            CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
            DTDIA01PREV,  VRDIA01PREV,
            DTINIPERPREV, DTFINPERPREV)
         VALUES(
            P_CDFILIAL,    P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
            V_NRPAGINA,    '30',         C_BC.CDEMPRESA,
            C_BC.CDBANCO,  C_BC.NMBANCO, V_TOTALDIA,
            null, null,
            P_DTPERIINIC,  P_DTPERIFINA);

         V_SALDO := V_SALDO + V_TOTALDIA;
         V_TOTALDIA := 0;
         V_NRCOLUNA   := V_NRCOLUNA + 1;          /*  GRAVA OS RECEBIMENTOS   */
         SELECT NVL(SUM(BX.VRBAIXAREC), 0) INTO V_TOTALDIA
         FROM BAIXARECEBIDA BX, CONTCORR CC
         WHERE
            (BX.CDREDUCONT = CC.CDREDUCONT)    AND
            (CC.CDEMPRESA  = C_BC.CDEMPRESA)   AND
            (CC.CDBANCO    = C_BC.CDBANCO)     AND
            (BX.DTBAIXAREC = P_DTPERIINIC);

         ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                          V_NRCOLUNA, V_DTPERI_01, V_TOTALDIA);

         V_SALDO := V_SALDO + V_TOTALDIA;
         V_TOTALDIA := 0;
         V_NRCOLUNA   := V_NRCOLUNA + 1;          /*  GRAVA OS PAGAMENTOS DO DIA ANTERIOR */
         SELECT NVL(SUM(BX.VRBAIXAPAG), 0) INTO V_TOTALDIA
         FROM BAIXAPAGA BX, CONTCORR CC
         WHERE
            (BX.CDREDUCONT = CC.CDREDUCONT)    AND
            (CC.CDEMPRESA  = C_BC.CDEMPRESA)   AND
            (CC.CDBANCO    = C_BC.CDBANCO)     AND
            (BX.DTBAIXAPAG = P_DTPERIINIC -1);

            ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                             V_NRCOLUNA, V_DTPERI_02, V_TOTALDIA);

         V_SALDO := V_SALDO - V_TOTALDIA;
         V_TOTALDIA := 0;
         V_NRCOLUNA   := V_NRCOLUNA + 1;          /*  GRAVA O SALDO FINAL */
         ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                          V_NRCOLUNA, V_DTPERI_03, V_SALDO);

         V_NRCOLUNA   := V_NRCOLUNA + 1;          /*  GRAVA CONTA GARANTIDA */
         SELECT SUM(VRCTRCREDCHQ) INTO V_TOTALDIA
         FROM CONTCORR CC
         WHERE
            (CC.CDEMPRESA  = C_BC.CDEMPRESA)   AND
            (CC.CDBANCO    = C_BC.CDBANCO);

         ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                          V_NRCOLUNA, V_DTPERI_04, V_TOTALDIA);

         V_TOTALDIA := 0;
      END IF;

      IF V_NRCOLUNA > 10 THEN
         V_NRPAGINA   := V_NRPAGINA + 1;
         V_NRCOLUNA   := 1;
         V_NRREGIENCA := V_NRREGIENCA + 1;
      END IF;

      V_NRREGIENCA := V_NRREGIENCA + 1;
   END LOOP;


   V_TOTMOVIANT := 0;
   FOR C_MOVI IN
   (SELECT NRPAGIPREV,
      MAX(DTDIA01PREV) DT01, MAX(DTDIA02PREV) DT02, MAX(DTDIA03PREV) DT03,
      MAX(DTDIA04PREV) DT04, MAX(DTDIA05PREV) DT05, MAX(DTDIA06PREV) DT06,
      MAX(DTDIA07PREV) DT07, MAX(DTDIA08PREV) DT08,
      SUM(VRDIA01PREV) DIA01, SUM(VRDIA02PREV) DIA02, SUM(VRDIA03PREV) DIA03,
      SUM(VRDIA04PREV) DIA04, SUM(VRDIA05PREV) DIA05, SUM(VRDIA06PREV) DIA06,
      SUM(VRDIA07PREV) DIA07, SUM(VRDIA08PREV) DIA08
    FROM TRAB_PREV
    WHERE
      CDFILIPREV = P_CDFILIAL AND
      NRPREVISAO = P_NRPREVISAO AND
      CDGRUPPREV <> '30'
    GROUP BY NRPAGIPREV) LOOP
      V_NRREGIENCA := V_NRREGIENCA + 1;
      INSERT INTO TRAB_PREV(
         CDFILIPREV,   NRPREVISAO, NRREGIPREV,
         NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
         CDITEMPREV,   DSITEMPREV,
         DTDIA01PREV,  VRDIA01PREV,
         DTDIA02PREV,  VRDIA02PREV,
         DTDIA03PREV,  VRDIA03PREV,
         DTDIA04PREV,  VRDIA04PREV,
         DTDIA05PREV,  VRDIA05PREV,
         DTDIA06PREV,  VRDIA06PREV,
         DTDIA07PREV,  VRDIA07PREV,
         DTDIA08PREV,  VRDIA08PREV,
         DTINIPERPREV, DTFINPERPREV)
      VALUES(
         P_CDFILIAL,    P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
         C_MOVI.NRPAGIPREV,    '99',         '',
         '',         '',
         C_MOVI.DT01, V_TOTMOVIANT,
         C_MOVI.DT02, V_TOTMOVIANT + C_MOVI.DIA01,
         C_MOVI.DT03, V_TOTMOVIANT + C_MOVI.DIA01 + C_MOVI.DIA02,
         C_MOVI.DT04, V_TOTMOVIANT + C_MOVI.DIA01 + C_MOVI.DIA02 + C_MOVI.DIA03,
         C_MOVI.DT05, V_TOTMOVIANT + C_MOVI.DIA01 + C_MOVI.DIA02 + C_MOVI.DIA03 + C_MOVI.DIA04,
         C_MOVI.DT06, V_TOTMOVIANT + C_MOVI.DIA01 + C_MOVI.DIA02 + C_MOVI.DIA03 + C_MOVI.DIA04 + C_MOVI.DIA05,
         C_MOVI.DT07, V_TOTMOVIANT + C_MOVI.DIA01 + C_MOVI.DIA02 + C_MOVI.DIA03 + C_MOVI.DIA04 + C_MOVI.DIA05 + C_MOVI.DIA06,
         C_MOVI.DT08, V_TOTMOVIANT + C_MOVI.DIA01 + C_MOVI.DIA02 + C_MOVI.DIA03 + C_MOVI.DIA04 + C_MOVI.DIA05 + C_MOVI.DIA06 + C_MOVI.DIA07,
         P_DTPERIINIC,  P_DTPERIFINA);

      V_TOTMOVIANT := V_TOTMOVIANT +
                      NVL(C_MOVI.DIA01, 0) + NVL(C_MOVI.DIA02, 0) +
                      NVL(C_MOVI.DIA03, 0) + NVL(C_MOVI.DIA04, 0) +
                      NVL(C_MOVI.DIA05, 0) + NVL(C_MOVI.DIA06, 0) +
                      NVL(C_MOVI.DIA07, 0) + NVL(C_MOVI.DIA08, 0);
   END LOOP;

END;
/
