/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_EXAME                   				    					   */
/* Tabela : EXAME                                                             */
/*                                                                            */
/* Criao:                                                                   */
/* 02/02/2005 - Jonathan Abdon Silva                           		     		*/
/*                                                                    	      */
/******************************************************************************/
IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_EXAME'  and
            type = 'TR'                   and
            u.uid = o.uid                 and
            u.name = USER)
  DROP TRIGGER DTULTATU_EXAME
  GO


CREATE TRIGGER DTULTATU_EXAME
ON EXAME
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'EXAME', NULL, 'CDEXAME='+ CDEXAME +';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE EXAME
      SET DTULTATUEXAM = GETDATE()
      FROM INSERTED
      WHERE
         (EXAME.CDEXAME  = INSERTED.CDEXAME)
   END;
END;
GO



