CREATE OR REPLACE PROCEDURE FCT_CANC_APURCAO_FATURAMENTO (
  P_NRORG IN NUMBER,
  P_NRSEQCONTRATO IN CLOB,
  P_CDOPERINCLUSAO IN FCT_APURACAO.CDOPERINCLUSAO%TYPE,
  P_DATAINI IN DATE,
  P_DATAFIN IN DATE,
  P_NRFATURACONT IN CLOB,
  P_NRRATEIOITEMFAT IN VARCHAR2 DEFAULT NULL,
  P_NRITFATURACONT IN VARCHAR2 DEFAULT NULL)
AS
  V_SITUVENC         VARCHAR2(1);
  V_VRFATURADO       FLOAT;
  V_NRFATURACONT     FCT_FATURACONT.NRFATURACONT%TYPE;
  V_VRAPURACAO       FLOAT;
  V_VRNOTAFISC       FLOAT;
  V_VRTOTESTRATEIO   FLOAT;
  
  V_P_NRFATURACONT VARCHAR2(4000);
  V_POS_UNDER NUMBER;
  V_POSINI NUMBER;
  V_NOVOCODIGO VARCHAR2(20);
  V_LISTA_APUR VARCHAR2(10);
  
  V_ERROR FCT_FATURACONT.NRFATURACONT%TYPE;
BEGIN
   NOVO_CODIGO_SC('LISTA', V_NOVOCODIGO, 1, P_NRORG);
   V_LISTA_APUR := SUBSTR(V_NOVOCODIGO, -10);
    
   BEGIN
      V_POSINI := 1;
      WHILE (V_POSINI < LENGTH(P_NRFATURACONT)) LOOP
  
          V_POS_UNDER := INSTR(P_NRFATURACONT, '_', V_POSINI + 3950);
          IF (V_POS_UNDER = 0) THEN
              V_POS_UNDER := LENGTH(P_NRFATURACONT);
          END IF;
  
          V_P_NRFATURACONT := SUBSTR(P_NRFATURACONT, V_POSINI, V_POS_UNDER-V_POSINI+1);
         
          V_VRFATURADO := 0;
          FOR C_APUR IN (
            SELECT DISTINCT FATURAMENTO.NRVENC, FATURAMENTO.VRFATURADO, FCT_APURACAO.NRAPURACAO,
                   FCT_APURACAO.CDFILIAL, FCT_APURACAO.NRLANCTONF, NOTAFISCAL.VRNOTAFISC,
                   FATURAMENTO.CHAVE, NOTAFISCAL.IDSTATUSNFE
            FROM (
               SELECT DISTINCT FCT_FATURACONT.NRFATURACONT AS NRVENC,
                       FCT_FATURACONT.VRFATURADO,
                       FCT_FATURACONT.NRORG,
                       FCT_FATURACONT.NRFATURACONT,
                       NULL AS NRAPURACAO,
                       AGRUPFAT.NRSEQCONTRATO,
                       'APU' AS CHAVE
               FROM FCT_FATURACONT
               INNER JOIN FCT_RELACAGRUPCONTFAT AGRUPFAT
                 ON FCT_FATURACONT.NRFATURACONT = AGRUPFAT.NRFATURACONT
                 AND FCT_FATURACONT.NRORG       = AGRUPFAT.NRORG
               WHERE (P_NRRATEIOITEMFAT IS NULL AND P_NRITFATURACONT IS NULL)
                 AND ((TRUNC(TO_DATE(FCT_FATURACONT.DTINICOMPET)) >= TRUNC(TO_DATE(P_DATAINI))) OR (P_DATAINI IS NULL))
                 AND ((TRUNC(TO_DATE(FCT_FATURACONT.DTFINCOMPET)) <= TRUNC(TO_DATE(P_DATAFIN))) OR (P_DATAFIN IS NULL))
               UNION ALL
               SELECT RAT.NRRATEIOITEMFAT AS NRVENC,
                   RAT.VRRATEADO AS VRFATURADO,
                   RAT.NRORG,
                   RAT.NRFATURACONT,
                   RAT.NRAPURACAO,
                   RAT.NRSEQCONTRATO,
                   'RAT' AS CHAVE
               FROM FCT_RATEIOITFATURACONT RAT
               WHERE (P_NRITFATURACONT IS NULL)
                 AND RAT.NRAPURACAO IN(SELECT NRAPURACAO
                                        FROM FCT_RATEIOITFATURACONT
                                        WHERE ((INSTR(P_NRRATEIOITEMFAT, '_' || TO_CHAR(NRRATEIOITEMFAT) || '_') > 0)))
               UNION ALL
               SELECT ITEM.NRITFATURACONT AS NRVENC,
                  ITEM.VRFATURADO,
                  ITEM.NRORG,
                  ITEM.NRFATURACONT,
                  ITEM.NRAPURACAO,
                  ITEM.NRSEQCONTRATO,
                  'ITEM' AS CHAVE
               FROM FCT_ITFATURACONT ITEM
               WHERE (P_NRRATEIOITEMFAT IS NULL)
                 AND ITEM.NRAPURACAO IN(SELECT NRAPURACAO
                                        FROM FCT_ITFATURACONT
                                        WHERE (INSTR(P_NRITFATURACONT, '_' || TO_CHAR(NRITFATURACONT) || '_') > 0))
            ) FATURAMENTO
            INNER JOIN FCT_RELACAPURACAOFATURA APURFATURA
               ON FATURAMENTO.NRFATURACONT = APURFATURA.NRFATURACONT
               AND FATURAMENTO.NRORG       = APURFATURA.NRORG
               AND (FATURAMENTO.NRAPURACAO = APURFATURA.NRAPURACAO
                    OR (FATURAMENTO.CHAVE = 'APU' AND FATURAMENTO.NRAPURACAO IS NULL))
            INNER JOIN FCT_APURACAO
                 ON APURFATURA.NRAPURACAO = FCT_APURACAO.NRAPURACAO
                 AND APURFATURA.NRORG     = FCT_APURACAO.NRORG
            JOIN NOTAFISCAL
               ON NOTAFISCAL.NRLANCTONF = FCT_APURACAO.NRLANCTONF
              AND NOTAFISCAL.CDFILIAL   = FCT_APURACAO.CDFILIAL
              AND NOTAFISCAL.NRORG      = FCT_APURACAO.NRORG
            WHERE (FATURAMENTO.NRORG = P_NRORG)
              --AND ((INSTR(P_NRSEQCONTRATO, '_' || TO_CHAR(FATURAMENTO.NRSEQCONTRATO) || '_') > 0) OR (P_NRSEQCONTRATO IS NULL))
              AND ((INSTR(V_P_NRFATURACONT, '_' || TO_CHAR(FATURAMENTO.NRFATURACONT) || '_') > 0) OR (V_P_NRFATURACONT IS NULL))
              AND (((NOTAFISCAL.IDSTATUS = 'P') OR (NOTAFISCAL.IDSTATUS = 'D')) OR (NOTAFISCAL.IDSTATUSNFE = 'C'))
          ) LOOP
              V_ERROR := C_APUR.NRVENC;
              
              IF C_APUR.CHAVE = 'APU' THEN

                  SELECT VENC.VRFATURADO
                    INTO V_VRFATURADO
                    FROM FCT_FATURACONT VENC
                   WHERE VENC.NRFATURACONT = C_APUR.NRVENC
                     AND VENC.NRORG        = P_NRORG;

                  UPDATE FCT_FATURACONT
                     SET VRFATURADO     = VRFATURADO - C_APUR.VRNOTAFISC,
                         VRFALTAFATURAR = VRFALTAFATURAR + C_APUR.VRNOTAFISC,
                         IDSITUACAO     = '1',
                         IDFORMAFATURA  = NULL
                   WHERE NRORG        = P_NRORG
                     AND NRFATURACONT = C_APUR.NRVENC;

                  UPDATE FCT_RATEIOITFATURACONT
                    SET NRAPURACAO       = NULL,
                        IDSITUVENCRATEIO = '1'
                    WHERE NRORG      = P_NRORG
                      AND NRAPURACAO = C_APUR.NRAPURACAO;

                  UPDATE FCT_ITFATURACONT
                    SET NRAPURACAO     = NULL,
                        IDSITUACAO     = '1',
                        VRFATURADO     = 0,
                        VRFALTAFATURAR = NVL(VRNEGCONTR, VRVENCIMENTO)
                    WHERE NRORG      = P_NRORG
                      AND NRAPURACAO = C_APUR.NRAPURACAO;

              ELSE
                  V_NRFATURACONT := SUBSTR(V_P_NRFATURACONT, 2, INSTR(V_P_NRFATURACONT, '_', 2) - 2);
                  V_VRFATURADO   := ROUND(V_VRFATURADO + C_APUR.VRFATURADO, 2);
                  V_VRAPURACAO   := ROUND(C_APUR.VRFATURADO, 2);
                  V_VRNOTAFISC   := ROUND(C_APUR.VRNOTAFISC, 2);
                  
                  IF (V_VRFATURADO = V_VRNOTAFISC) THEN
                    V_SITUVENC := '1';
                  ELSE
                    V_SITUVENC := '6';
                  END IF;

                  UPDATE FCT_FATURACONT
                    SET VRFATURADO     = ROUND(VRFATURADO     - V_VRAPURACAO, 2),
                        VRFALTAFATURAR = ROUND(VRFALTAFATURAR + V_VRAPURACAO, 2),
                        IDSITUACAO     = V_SITUVENC
                    WHERE NRFATURACONT = V_NRFATURACONT
                      AND NRORG        = P_NRORG;

                  IF C_APUR.CHAVE = 'ITEM' THEN
                    
                    UPDATE FCT_ITFATURACONT
                    SET IDSITUACAO     = '1',
                        VRFATURADO     = ROUND(VRFATURADO     - V_VRAPURACAO, 2),
                        VRFALTAFATURAR = ROUND(VRFALTAFATURAR + V_VRAPURACAO, 2),
                        NRAPURACAO     = NULL
                    WHERE NRITFATURACONT = C_APUR.NRVENC
                      AND NRORG          = P_NRORG;

                    FOR C_RATEIOS IN (
                      SELECT (SELECT SUM(VRRATEADO)
                              FROM FCT_RATEIOITFATURACONT
                              WHERE NRFATURACONT  = RAT.NRFATURACONT
                                AND NRESTRUTURAM  = RAT.NRESTRUTURAM) AS VRRATEADO,
                             RAT.NRESTRUTURAM
                      FROM FCT_RATEIOITFATURACONT RAT
                      WHERE RAT.NRORG          = P_NRORG
                        AND RAT.NRFATURACONT   = V_NRFATURACONT
                        AND RAT.NRITFATURACONT = C_APUR.NRVENC
                    ) LOOP
                      
                      BEGIN
                        SELECT NVL(SUM(VRRATEADO), 0)
                        INTO V_VRTOTESTRATEIO
                        FROM FCT_RATEIOITFATURACONT RATEIO
                        JOIN FCT_ITFATURACONT ITEM
                          ON RATEIO.NRITFATURACONT = ITEM.NRITFATURACONT
                          AND RATEIO.NRORG         = ITEM.NRORG
                        WHERE RATEIO.NRFATURACONT  = V_NRFATURACONT
                          AND RATEIO.NRESTRUTURAM  = C_RATEIOS.NRESTRUTURAM
                          AND IDSITUACAO IN('1', '6');
                      EXCEPTION WHEN NO_DATA_FOUND THEN
                        V_VRTOTESTRATEIO := 0;
                      END;

                      IF ROUND(C_RATEIOS.VRRATEADO, 2) = ROUND(V_VRTOTESTRATEIO, 2) THEN
                        V_SITUVENC := '1';
                      ELSE
                        V_SITUVENC := '6';
                      END IF;

                      UPDATE FCT_RATEIOITFATURACONT
                      SET IDSITUVENCRATEIO = V_SITUVENC,
                          NRAPURACAO       = NULL
                      WHERE NRFATURACONT  = V_NRFATURACONT
                        AND NRESTRUTURAM  = C_RATEIOS.NRESTRUTURAM
                        AND NRORG         = P_NRORG;

                    END LOOP;

                  ELSE IF C_APUR.CHAVE = 'RAT' THEN

                    FOR C_ITENSRATEIO IN (SELECT VRFATURADO,
                                            ROUND(VRFALTAFATURAR, 2) AS VRFALTAFATURAR,
                                            ROUND(VRVENCIMENTO, 2) AS VRVENCIMENTO,
                                            NRITFATURACONT
                                          FROM FCT_ITFATURACONT
                                          WHERE NRORG           = P_NRORG
                                            AND NRITFATURACONT IN (SELECT NRITFATURACONT
                                                                   FROM FCT_RATEIOITFATURACONT
                                                                   WHERE NRAPURACAO = C_APUR.NRAPURACAO
                                                                      AND NRORG     = P_NRORG)
                    ) LOOP

                      SELECT NVL(SUM(VRRATEADO), 0)
                        INTO V_VRTOTESTRATEIO
                        FROM FCT_RATEIOITFATURACONT RATEIO
                       WHERE RATEIO.NRFATURACONT   = V_NRFATURACONT
                         AND RATEIO.NRITFATURACONT = C_ITENSRATEIO.NRITFATURACONT
                         AND RATEIO.IDSITUVENCRATEIO IN ('1', '6');

                      IF ROUND(V_VRTOTESTRATEIO + C_ITENSRATEIO.VRFATURADO, 2) = ROUND(C_ITENSRATEIO.VRVENCIMENTO, 2) THEN
                        V_SITUVENC := '1';
                      ELSE
                        V_SITUVENC := '6';
                      END IF;

                      UPDATE FCT_ITFATURACONT
                      SET IDSITUACAO     = V_SITUVENC,
                          VRFATURADO     = ROUND(VRFATURADO     - C_ITENSRATEIO.VRFATURADO, 2),
                          VRFALTAFATURAR = ROUND(VRFALTAFATURAR + C_ITENSRATEIO.VRFATURADO, 2)
                      WHERE NRORG          = P_NRORG
                        AND NRITFATURACONT = C_ITENSRATEIO.NRITFATURACONT;

                    END LOOP;

                    UPDATE FCT_RATEIOITFATURACONT
                       SET NRAPURACAO       = NULL,
                           IDSITUVENCRATEIO = '1'
                     WHERE NRORG      = P_NRORG
                       AND NRAPURACAO = C_APUR.NRAPURACAO;

                  END IF;

                END IF;

              END IF;
              
              BEGIN
                 INSERT INTO LISTA (
                     NRLISTA,
                     CDLISTA,
                     NRORG,
                     DTINCLUSAO,
                     NRORGINCLUSAO,
                     CDOPERINCLUSAO,
                     IDATIVO
                 )
                 VALUES (
                     V_LISTA_APUR,
                     TO_CHAR(C_APUR.NRAPURACAO),
                     P_NRORG,
                     SYSDATE,
                     P_NRORG,
                     P_CDOPERINCLUSAO,
                     'S'
                 );
              EXCEPTION
                 WHEN OTHERS THEN NULL;
              END;
              
          END LOOP; -- C_APUR
      
          V_POSINI := V_POS_UNDER;
      END LOOP;
  
      FOR C_DELAPU IN (SELECT FCT_APURACAO.NRLANCTONF, FCT_APURACAO.CDFILIAL, FCT_APURACAO.NRAPURACAO,
                              NOTAFISCAL.IDSTATUSNFE
                         FROM FCT_APURACAO
                        INNER JOIN FCT_RELACAPURACAOFATURA APURFAT
                           ON FCT_APURACAO.NRAPURACAO = APURFAT.NRAPURACAO
                          AND FCT_APURACAO.NRORG     = APURFAT.NRORG
                        INNER JOIN NOTAFISCAL
                           ON NOTAFISCAL.NRLANCTONF = FCT_APURACAO.NRLANCTONF 
                          AND NOTAFISCAL.CDFILIAL = FCT_APURACAO.CDFILIAL
                          AND NOTAFISCAL.NRORG = FCT_APURACAO.NRORG
                        INNER JOIN LISTA 
                           ON TO_NUMBER(LISTA.CDLISTA) = APURFAT.NRAPURACAO 
                        WHERE LISTA.NRLISTA = V_LISTA_APUR)
      LOOP
           DELETE FROM FCT_RELACAPURACAOFATURA
           WHERE NRAPURACAO = C_DELAPU.NRAPURACAO
            AND NRORG = P_NRORG;
            
           DELETE FROM FCT_APURACAO
            WHERE NRORG      = P_NRORG
              AND NRAPURACAO = C_DELAPU.NRAPURACAO;
              
           DELETE FROM RATEIONF
            WHERE NRORG = P_NRORG
              AND NRLANCTONF = C_DELAPU.NRLANCTONF
              AND CDFILIAL = C_DELAPU.CDFILIAL;
          
          /* Agora, a procedure tambm passou a considerar as notas cuja transmisso foi cancelada.
             Neste caso, a nota fiscal no  excluda, apenas   desvinculada, o que  realizado no delete 
             da FCT_APURACAO, acima.*/
          IF (C_DELAPU.IDSTATUSNFE <> 'C') THEN 
              
            DELETA_NF(C_DELAPU.CDFILIAL, C_DELAPU.NRLANCTONF);

          END IF;
      END LOOP;
      
      DELETE FROM LISTA
       WHERE NRLISTA = V_LISTA_APUR;
      
      COMMIT; 
   EXCEPTION
      WHEN OTHERS THEN BEGIN
         DELETE FROM LISTA
          WHERE NRLISTA = V_LISTA_APUR;
          
         RAISE_APPLICATION_ERROR(-20004, 'ERRO_CANC'||'##'||V_ERROR||'##'||SQLERRM);
      END;
   END;
   
END;
/